]>
Commit | Line | Data |
---|---|---|
8d876415 DK |
1 | #!/bin/sh -- # no runable script, just for vi |
2 | ||
5d76cee1 | 3 | EXIT_CODE=0 |
8c1dd12c | 4 | |
68042532 DK |
5 | while [ -n "$1" ]; do |
6 | if [ "$1" = "-q" ]; then | |
7 | export MSGLEVEL=2 | |
8 | elif [ "$1" = "-v" ]; then | |
9 | export MSGLEVEL=4 | |
10 | elif [ "$1" = '--color=no' ]; then | |
11 | export MSGCOLOR='NO' | |
61e92778 DK |
12 | elif [ "$1" = '--color=yes' ]; then |
13 | export MSGCOLOR='YES' | |
14 | elif [ "$1" = '--color' ]; then | |
15 | export MSGCOLOR="$(echo "$2" | tr 'a-z' 'A-Z')" | |
16 | shift | |
17 | elif [ "$1" = '--level' ]; then | |
18 | export MSGLEVEL=$2 | |
19 | shift | |
68042532 DK |
20 | else |
21 | echo >&2 "WARNING: Unknown parameter »$1« will be ignored" | |
22 | fi | |
23 | shift | |
24 | done | |
25 | export MSGLEVEL="${MSGLEVEL:-3}" | |
26 | ||
8d876415 | 27 | # we all like colorful messages |
61e92778 | 28 | if [ "${MSGCOLOR:-YES}" = 'YES' ]; then |
27cb4f6c | 29 | if [ ! -t 1 ]; then # but check that we output to a terminal |
1290422a DK |
30 | export MSGCOLOR='NO' |
31 | fi | |
32 | fi | |
33 | ||
34 | ||
35 | if [ "$MSGCOLOR" != 'NO' ]; then | |
36 | CERROR="\033[1;31m" # red | |
37 | CWARNING="\033[1;33m" # yellow | |
38 | CMSG="\033[1;32m" # green | |
39 | CINFO="\033[1;96m" # light blue | |
40 | CDEBUG="\033[1;94m" # blue | |
41 | CNORMAL="\033[0;39m" # default system console color | |
42 | CDONE="\033[1;32m" # green | |
43 | CPASS="\033[1;32m" # green | |
44 | CFAIL="\033[1;31m" # red | |
45 | CCMD="\033[1;35m" # pink | |
682a3bf7 | 46 | fi |
8d876415 | 47 | |
de81b2e2 DK |
48 | msgprintf() { |
49 | local START="$1" | |
50 | local MIDDLE="$2" | |
51 | local END="$3" | |
52 | shift 3 | |
53 | if [ -n "$1" ]; then | |
54 | printf "$START " "$1" | |
d73840dc | 55 | shift |
de81b2e2 | 56 | while [ -n "$1" ]; do |
bc8f83a5 | 57 | printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghks]\)#apt-\1#')" |
de81b2e2 DK |
58 | shift |
59 | done | |
60 | fi | |
61 | printf "${END}" | |
2a2a7ef4 | 62 | } |
de81b2e2 DK |
63 | msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; } |
64 | msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; } | |
65 | msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; } | |
66 | msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; } | |
67 | msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; } | |
68 | msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; } | |
69 | msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; } | |
70 | msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; } | |
71 | msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; } | |
72 | msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; } | |
73 | msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; } | |
3c528b91 | 74 | msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; } |
1501a2c9 | 75 | msgreportheader() { |
68042532 | 76 | if [ -n "$MSGTEST_MSG" ]; then |
1501a2c9 | 77 | test "$1" != 'msgfailoutput' || echo |
ae7fce5a DK |
78 | if [ -n "$MSGTEST_MSGMSG" ]; then |
79 | echo "$MSGTEST_MSGMSG" | |
80 | fi | |
22ac12b2 | 81 | if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then |
1501a2c9 | 82 | echo "${CFAIL}Part of the test group: $MSGTEST_GRP" |
22ac12b2 | 83 | fi |
68042532 DK |
84 | echo -n "$MSGTEST_MSG" |
85 | unset MSGTEST_MSG | |
86 | fi | |
1501a2c9 DK |
87 | } |
88 | msgskip() { | |
89 | msgreportheader 'msgskip' | |
68ba0b7f DK |
90 | if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2; |
91 | else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi | |
92 | } | |
5229b285 | 93 | msgfail() { |
1501a2c9 | 94 | msgreportheader 'msgfail' |
68042532 | 95 | if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2; |
3c528b91 | 96 | else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi |
03aa0847 | 97 | if [ -n "$APT_DEBUG_TESTS" ]; then |
912a6131 | 98 | APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH="${LIBRARYPATH}:${LD_LIBRARY_PATH}" $SHELL |
03aa0847 | 99 | fi |
5229b285 DK |
100 | EXIT_CODE=$((EXIT_CODE+1)); |
101 | } | |
9beb11aa DK |
102 | MSGGROUP_LEVEL=0 |
103 | msggroup() { | |
104 | if [ -n "$1" ]; then | |
105 | if [ $MSGGROUP_LEVEL = 0 ]; then | |
106 | MSGTEST_GRP='NEXT' | |
107 | fi | |
108 | MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1)); | |
109 | else | |
110 | MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1)); | |
111 | if [ $MSGGROUP_LEVEL = 0 ]; then | |
112 | unset MSGTEST_GRP | |
113 | fi | |
114 | fi | |
115 | } | |
8d876415 DK |
116 | |
117 | # enable / disable Debugging | |
fc89263e DK |
118 | if [ $MSGLEVEL -le 0 ]; then |
119 | msgdie() { true; } | |
120 | fi | |
121 | if [ $MSGLEVEL -le 1 ]; then | |
122 | msgwarn() { true; } | |
123 | msgnwarn() { true; } | |
124 | fi | |
125 | if [ $MSGLEVEL -le 2 ]; then | |
ae7fce5a DK |
126 | msgmsg() { |
127 | MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")" | |
128 | } | |
fc89263e | 129 | msgnmsg() { true; } |
9beb11aa DK |
130 | msgtest() { |
131 | MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")" | |
132 | if [ "$MSGTEST_GRP" = 'NEXT' ]; then | |
133 | MSGTEST_GRP="$MSGTEST_MSG" | |
134 | fi | |
135 | } | |
3c528b91 | 136 | msgpass() { printf " ${CPASS}P${CNORMAL}"; } |
fc89263e DK |
137 | fi |
138 | if [ $MSGLEVEL -le 3 ]; then | |
139 | msginfo() { true; } | |
140 | msgninfo() { true; } | |
141 | fi | |
142 | if [ $MSGLEVEL -le 4 ]; then | |
143 | msgdebug() { true; } | |
144 | msgndebug() { true; } | |
145 | fi | |
146 | msgdone() { | |
147 | if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] || | |
148 | [ "$1" = "info" -a $MSGLEVEL -le 3 ] || | |
149 | [ "$1" = "msg" -a $MSGLEVEL -le 2 ] || | |
150 | [ "$1" = "warn" -a $MSGLEVEL -le 1 ] || | |
151 | [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then | |
152 | true; | |
153 | else | |
3c528b91 | 154 | printf "${CDONE}DONE${CNORMAL}\n"; |
fc89263e DK |
155 | fi |
156 | } | |
e43a426e MV |
157 | getaptconfig() { |
158 | if [ -f ./aptconfig.conf ]; then | |
5465192b | 159 | echo "$(readlink -f ./aptconfig.conf)" |
e43a426e | 160 | elif [ -f ../aptconfig.conf ]; then |
5465192b DK |
161 | echo "$(readlink -f ../aptconfig.conf)" |
162 | elif [ -f ../../aptconfig.conf ]; then | |
163 | echo "$(readlink -f ../../aptconfig.conf)" | |
164 | elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then | |
165 | echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")" | |
166 | fi | |
e43a426e | 167 | } |
8d876415 DK |
168 | runapt() { |
169 | msgdebug "Executing: ${CCMD}$*${CDEBUG} " | |
846856f4 DK |
170 | local CMD="$1" |
171 | shift | |
3abb6a6a | 172 | case "$CMD" in |
a311fb96 | 173 | sh|aptitude|*/*|command) ;; |
3b8eb3bc DK |
174 | *) CMD="${BUILDDIRECTORY}/$CMD";; |
175 | esac | |
3abb6a6a | 176 | MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${LIBRARYPATH} "$CMD" "$@" |
8d876415 | 177 | } |
846856f4 DK |
178 | aptconfig() { runapt apt-config "$@"; } |
179 | aptcache() { runapt apt-cache "$@"; } | |
180 | aptcdrom() { runapt apt-cdrom "$@"; } | |
181 | aptget() { runapt apt-get "$@"; } | |
182 | aptftparchive() { runapt apt-ftparchive "$@"; } | |
183 | aptkey() { runapt apt-key "$@"; } | |
184 | aptmark() { runapt apt-mark "$@"; } | |
4f6d26b4 | 185 | aptsortpkgs() { runapt apt-sortpkgs "$@"; } |
796673c3 | 186 | apt() { runapt apt "$@"; } |
3b8eb3bc DK |
187 | apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; } |
188 | aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; } | |
189 | aptitude() { runapt aptitude "$@"; } | |
8d50b63f | 190 | aptextracttemplates() { runapt apt-extracttemplates "$@"; } |
3082603f | 191 | aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; } |
ad7e0941 | 192 | aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; } |
3b8eb3bc | 193 | |
158fda31 | 194 | dpkg() { |
b0be0e09 | 195 | "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@" |
158fda31 | 196 | } |
ce7f128c | 197 | dpkgcheckbuilddeps() { |
63c71412 | 198 | command dpkg-checkbuilddeps --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" "$@" |
b6b5a542 | 199 | } |
3fa950f1 | 200 | gdb() { |
b07aeb1a DK |
201 | local CMD |
202 | case "$1" in | |
203 | aptget) CMD="apt-get";; | |
204 | aptcache) CMD="apt-cache";; | |
5465192b DK |
205 | aptcdrom) CMD="apt-cdrom";; |
206 | aptconfig) CMD="apt-config";; | |
b07aeb1a DK |
207 | aptmark) CMD="apt-mark";; |
208 | apthelper) CMD="apt-helper";; | |
3d8232bf | 209 | aptftparchive) CMD="apt-ftparchive";; |
63c71412 | 210 | dpkg) shift; runapt "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" "$@"; return;; |
b07aeb1a DK |
211 | *) CMD="$1";; |
212 | esac | |
ce928105 | 213 | shift |
921a9626 DK |
214 | if [ "${CMD##*/}" = "$CMD" ]; then |
215 | CMD="${BUILDDIRECTORY}/${CMD}" | |
216 | fi | |
217 | runapt command gdb --quiet -ex run "$CMD" --args "$CMD" "$@" | |
ae99ce2e | 218 | } |
8d876415 | 219 | |
8c1dd12c | 220 | exitwithstatus() { |
f91bd741 MV |
221 | # error if we about to overflow, but ... |
222 | # "255 failures ought to be enough for everybody" | |
5d76cee1 MV |
223 | if [ $EXIT_CODE -gt 255 ]; then |
224 | msgdie "Total failure count $EXIT_CODE too big" | |
f91bd741 | 225 | fi |
5d76cee1 | 226 | exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255)); |
8c1dd12c MV |
227 | } |
228 | ||
804d4a0d DK |
229 | shellsetedetector() { |
230 | local exit_status=$? | |
231 | if [ "$exit_status" != '0' ]; then | |
3c528b91 | 232 | printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n" |
804d4a0d DK |
233 | if [ "$EXIT_CODE" = '0' ]; then |
234 | EXIT_CODE="$exit_status" | |
235 | fi | |
236 | fi | |
237 | } | |
238 | ||
b720d0bd | 239 | addtrap() { |
8437b7d4 DK |
240 | if [ "$1" = 'prefix' ]; then |
241 | CURRENTTRAP="$2 $CURRENTTRAP" | |
242 | else | |
243 | CURRENTTRAP="$CURRENTTRAP $1" | |
244 | fi | |
804d4a0d | 245 | trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM |
b720d0bd | 246 | } |
8d876415 | 247 | |
bc8f83a5 DK |
248 | escape_shell() { |
249 | echo "$@" | sed -e "s#'#'\"'\"'#g" | |
250 | } | |
251 | ||
8d876415 | 252 | setupenvironment() { |
0d303f17 DK |
253 | # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir) |
254 | if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then | |
255 | unset TMPDIR | |
256 | fi | |
63c71412 | 257 | TMPWORKINGDIRECTORY="$(mktemp -d)" |
bc8f83a5 DK |
258 | addtrap "cd /; rm -rf '$(escape_shell "$TMPWORKINGDIRECTORY")';" |
259 | if [ -n "$TMPDIR_ADD" ]; then | |
260 | TMPWORKINGDIRECTORY="${TMPWORKINGDIRECTORY}/${TMPDIR_ADD}" | |
261 | mkdir -p "$TMPWORKINGDIRECTORY" | |
262 | unset TMPDIR_ADD | |
263 | export TMPDIR="$TMPWORKINGDIRECTORY" | |
264 | fi | |
63c71412 | 265 | msgninfo "Preparing environment for ${0##*/} in ${TMPWORKINGDIRECTORY}…" |
5c0dd6fc | 266 | |
03aa0847 | 267 | mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded" |
68ba0b7f DK |
268 | if [ "$(id -u)" = '0' ]; then |
269 | # relax permissions so that running as root with user switching works | |
270 | umask 022 | |
03aa0847 DK |
271 | chmod 711 "$TMPWORKINGDIRECTORY" |
272 | chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded" | |
68ba0b7f DK |
273 | fi |
274 | ||
63c71412 | 275 | TESTDIRECTORY="$(readlink -f "$(dirname $0)")" |
5c0dd6fc | 276 | # allow overriding the default BUILDDIR location |
63c71412 DK |
277 | SOURCEDIRECTORY="${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}" |
278 | BUILDDIRECTORY="${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}" | |
279 | LIBRARYPATH="${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}" | |
280 | METHODSDIR="${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}" | |
281 | APTHELPERBINDIR="${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}" | |
282 | APTWEBSERVERBINDIR="${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}" | |
283 | APTINTERNALSOLVER="${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}" | |
284 | APTDUMPSOLVER="${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}" | |
8d876415 | 285 | test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first" |
5c0dd6fc MV |
286 | # ----- |
287 | ||
63c71412 | 288 | cd "$TMPWORKINGDIRECTORY" |
cd725954 | 289 | mkdir rootdir aptarchive keys |
8d876415 | 290 | cd rootdir |
b29c3712 | 291 | mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d |
8fe964f1 | 292 | mkdir -p usr/bin var/cache var/lib var/log tmp |
cffea9af | 293 | mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers |
cd725954 | 294 | touch var/lib/dpkg/available |
8d876415 | 295 | mkdir -p usr/lib/apt |
63c71412 | 296 | ln -s "${METHODSDIR}" usr/lib/apt/methods |
1f6cf9e7 DK |
297 | if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then |
298 | mkdir -p usr/lib/apt/solvers | |
299 | ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump | |
300 | ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt | |
301 | echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf | |
302 | fi | |
291a386f MV |
303 | # use the autoremove from the BUILDDIRECTORY if its there, otherwise |
304 | # system | |
63c71412 DK |
305 | if [ -e "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" ]; then |
306 | ln -s "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" etc/apt/apt.conf.d/01autoremove | |
291a386f MV |
307 | else |
308 | ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove | |
309 | fi | |
8d876415 | 310 | cd .. |
63c71412 DK |
311 | local BASENAME="${0##*/}" |
312 | local PACKAGESFILE="Packages-${BASENAME#*-}" | |
53ea1b56 DK |
313 | if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then |
314 | cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages | |
8f8169ac | 315 | fi |
63c71412 | 316 | local SOURCESSFILE="Sources-${BASENAME#*-}" |
53ea1b56 DK |
317 | if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then |
318 | cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources | |
8f8169ac | 319 | fi |
3abb6a6a DK |
320 | find "$TESTDIRECTORY" \( -name '*.pub' -o -name '*.sec' \) -exec cp '{}' keys/ \; |
321 | chmod 644 keys/* | |
63c71412 | 322 | ln -s "${TMPWORKINGDIRECTORY}/keys/joesixpack.pub" rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg |
d6cf2345 | 323 | |
cffea9af | 324 | echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf |
94eb3bee | 325 | echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf |
8d876415 | 326 | echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf |
9d2a8a73 | 327 | echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf |
23e64f6d DK |
328 | # either store apt-key were we can access it, even if we run it as a different user |
329 | #cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/" | |
330 | #chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key" | |
331 | #echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf | |
332 | # destroys coverage reporting though, so we disable changing user for the calling gpgv | |
333 | echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf | |
68ba0b7f | 334 | if [ "$(id -u)" = '0' ]; then |
23e64f6d | 335 | echo 'Binary::gpgv::Debug::NoDropPrivs "true";' >>aptconfig.conf |
68ba0b7f | 336 | fi |
b0be0e09 | 337 | |
63c71412 | 338 | cat > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF |
b0be0e09 DK |
339 | #!/bin/sh |
340 | set -e | |
3abb6a6a | 341 | if [ -r '${TMPWORKINGDIRECTORY}/noopchroot.so' ]; then |
63c71412 | 342 | if [ -n "\$LD_LIBRARY_PATH" ]; then |
3abb6a6a | 343 | export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}:'"\${LD_LIBRARY_PATH}" |
b0be0e09 | 344 | else |
3abb6a6a | 345 | export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}' |
b0be0e09 | 346 | fi |
921a9626 | 347 | if [ -n "\$LD_PRELOAD" ]; then |
63c71412 | 348 | export LD_PRELOAD="noopchroot.so \${LD_PRELOAD}" |
921a9626 | 349 | else |
63c71412 | 350 | export LD_PRELOAD="noopchroot.so" |
921a9626 DK |
351 | fi |
352 | fi | |
63c71412 DK |
353 | EOF |
354 | cp "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" | |
355 | cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF | |
3abb6a6a DK |
356 | exec fakeroot '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\ |
357 | --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\ | |
63c71412 DK |
358 | --force-not-root --force-bad-path "\$@" |
359 | EOF | |
360 | cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" <<EOF | |
3abb6a6a DK |
361 | exec fakeroot gdb --quiet -ex run '${DPKG:-dpkg}' --args '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\ |
362 | --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\ | |
b0be0e09 DK |
363 | --force-not-root --force-bad-path "\$@" |
364 | EOF | |
921a9626 | 365 | chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" |
b0be0e09 DK |
366 | echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg |
367 | ||
533fe3d1 DK |
368 | { |
369 | if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then | |
370 | echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it… | |
371 | fi | |
87d6947d | 372 | echo 'quiet "0";' |
533fe3d1 DK |
373 | echo 'quiet::NoUpdate "true";' |
374 | echo 'quiet::NoStatistic "true";' | |
375 | # too distracting for users, but helpful to detect changes | |
376 | echo 'Acquire::Progress::Ignore::ShowErrorText "true";' | |
377 | echo 'Acquire::Progress::Diffpercent "true";' | |
378 | # in testcases, it can appear as if localhost has a rotation setup, | |
379 | # hide this as we can't really deal with it properly | |
380 | echo 'Acquire::Failure::ShowIP "false";' | |
ebca2f25 DK |
381 | # fakeroot can't fake everything, so disabled in production but good for tests |
382 | echo 'APT::Sandbox::Verify "true";' | |
533fe3d1 | 383 | } >> aptconfig.conf |
d6cf2345 | 384 | |
68ba0b7f DK |
385 | cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem" |
386 | if [ "$(id -u)" = '0' ]; then | |
387 | chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem" | |
388 | fi | |
389 | echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https | |
d6cf2345 | 390 | echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary |
23d35ec1 | 391 | echo 'Acquire::Connect::AddrConfig "false";' > rootdir/etc/apt/apt.conf.d/connect-addrconfig |
276e51dd | 392 | configcompression '.' 'gz' #'bz2' 'lzma' 'xz' |
c5ede4ca | 393 | confighashes 'SHA1' # these are tests, not security best-practices |
77a45beb | 394 | |
4bb006d1 | 395 | # create some files in /tmp and look at user/group to get what this means |
eab57e08 | 396 | TEST_DEFAULT_USER="$(id -un)" |
4bb006d1 DK |
397 | if [ "$(uname)" = 'GNU/kFreeBSD' ]; then |
398 | TEST_DEFAULT_GROUP='root' | |
399 | else | |
eab57e08 | 400 | TEST_DEFAULT_GROUP="$(id -gn)" |
4bb006d1 DK |
401 | fi |
402 | ||
ce7f128c | 403 | # cleanup the environment a bit |
995a4bf6 | 404 | # prefer our apt binaries over the system apt binaries |
8c617819 | 405 | export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin" |
be233796 | 406 | export LC_ALL=C.UTF-8 |
3b8eb3bc | 407 | unset LANGUAGE APT_CONFIG |
ce7f128c | 408 | unset GREP_OPTIONS DEB_BUILD_PROFILES |
59f57473 | 409 | unset http_proxy HTTP_PROXY https_proxy HTTPS_PROXY no_proxy |
8d876415 DK |
410 | msgdone "info" |
411 | } | |
412 | ||
ea65d079 DK |
413 | getarchitecture() { |
414 | if [ "$1" = "native" -o -z "$1" ]; then | |
415 | eval `aptconfig shell ARCH APT::Architecture` | |
416 | if [ -n "$ARCH" ]; then | |
417 | echo $ARCH | |
418 | else | |
5834d7a1 | 419 | dpkg --print-architecture |
ea65d079 DK |
420 | fi |
421 | else | |
422 | echo $1 | |
423 | fi | |
424 | } | |
425 | ||
53ea1b56 | 426 | getarchitectures() { |
081c9d44 | 427 | aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' ' |
53ea1b56 DK |
428 | } |
429 | ||
3dcdc1f9 DK |
430 | getarchitecturesfromcommalist() { |
431 | echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/" | |
432 | } | |
433 | ||
8d876415 | 434 | configarchitecture() { |
18908589 DK |
435 | { |
436 | echo "APT::Architecture \"$(getarchitecture $1)\";" | |
437 | while [ -n "$1" ]; do | |
438 | echo "APT::Architectures:: \"$(getarchitecture $1)\";" | |
439 | shift | |
440 | done | |
441 | } >rootdir/etc/apt/apt.conf.d/01multiarch.conf | |
53ea1b56 DK |
442 | configdpkg |
443 | } | |
444 | ||
445 | configdpkg() { | |
446 | if [ ! -e rootdir/var/lib/dpkg/status ]; then | |
63c71412 DK |
447 | local BASENAME="${0##*/}" |
448 | local STATUSFILE="status-${BASENAME#*-}" | |
53ea1b56 DK |
449 | if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then |
450 | cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status | |
451 | else | |
452 | echo -n > rootdir/var/lib/dpkg/status | |
453 | fi | |
454 | fi | |
18908589 | 455 | rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg |
846856f4 | 456 | if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then |
53ea1b56 DK |
457 | local ARCHS="$(getarchitectures)" |
458 | if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then | |
459 | DPKGARCH="$(dpkg --print-architecture)" | |
460 | for ARCH in ${ARCHS}; do | |
feae193b | 461 | if [ "${ARCH}" != "${DPKGARCH}" ]; then |
18908589 | 462 | if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then |
feae193b | 463 | # old-style used e.g. in Ubuntu-P – and as it seems travis |
18908589 DK |
464 | echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg |
465 | echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
feae193b DK |
466 | fi |
467 | fi | |
53ea1b56 DK |
468 | done |
469 | if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then | |
05343a22 DK |
470 | # dpkg doesn't really check the version as long as it is fully installed, |
471 | # but just to be sure we choose one above the required version | |
472 | insertinstalledpackage 'dpkg' "all" '1.16.2+fake' | |
53ea1b56 DK |
473 | fi |
474 | fi | |
475 | fi | |
8d876415 DK |
476 | } |
477 | ||
0c787570 DK |
478 | configdpkgnoopchroot() { |
479 | # create a library to noop chroot() and rewrite maintainer script executions | |
480 | # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown | |
481 | # chroot directory dpkg could chroot into to execute the maintainer scripts | |
482 | msgtest 'Building library to preload to make maintainerscript work in' 'dpkg' | |
63c71412 | 483 | cat > noopchroot.c << EOF |
0c787570 DK |
484 | #define _GNU_SOURCE |
485 | #include <stdio.h> | |
486 | #include <stdlib.h> | |
487 | #include <string.h> | |
488 | #include <dlfcn.h> | |
489 | ||
490 | static char * chrootdir = NULL; | |
491 | ||
492 | int chroot(const char *path) { | |
493 | printf("WARNING: CHROOTing to %s was ignored!\n", path); | |
494 | free(chrootdir); | |
495 | chrootdir = strdup(path); | |
496 | return 0; | |
497 | } | |
498 | int execvp(const char *file, char *const argv[]) { | |
499 | static int (*func_execvp) (const char *, char * const []) = NULL; | |
500 | if (func_execvp == NULL) | |
501 | func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp"); | |
502 | if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0) | |
503 | return func_execvp(file, argv); | |
504 | printf("REWRITE execvp call %s into %s\n", file, chrootdir); | |
950733c9 JAK |
505 | char *newfile; |
506 | if (asprintf(&newfile, "%s%s", chrootdir, file) == -1) { | |
507 | perror("asprintf"); | |
508 | return -1; | |
509 | } | |
b0be0e09 | 510 | char const * const baseadmindir = "/var/lib/dpkg"; |
950733c9 JAK |
511 | char *admindir; |
512 | if (asprintf(&admindir, "%s%s", chrootdir, baseadmindir) == -1) { | |
513 | perror("asprintf"); | |
514 | return -1; | |
515 | } | |
b0be0e09 | 516 | setenv("DPKG_ADMINDIR", admindir, 1); |
0c787570 DK |
517 | return func_execvp(newfile, argv); |
518 | } | |
519 | EOF | |
950733c9 | 520 | testsuccess --nomsg gcc -Wall -fPIC -shared -o noopchroot.so noopchroot.c -ldl |
0c787570 | 521 | } |
276e51dd DK |
522 | configcompression() { |
523 | while [ -n "$1" ]; do | |
524 | case "$1" in | |
3c528b91 MO |
525 | '.') printf ".\t.\tcat\n";; |
526 | 'gz') printf "gzip\tgz\tgzip\n";; | |
527 | 'bz2') printf "bzip2\tbz2\tbzip2\n";; | |
528 | 'lzma') printf "lzma\tlzma\txz --format=lzma\n";; | |
3c528b91 | 529 | *) printf "$1\t$1\t$1\n";; |
276e51dd DK |
530 | esac |
531 | shift | |
63c71412 | 532 | done > "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" |
276e51dd | 533 | } |
c5ede4ca DK |
534 | confighashes() { |
535 | { | |
536 | echo 'APT::FTPArchive {' | |
537 | { | |
538 | while [ -n "$1" ]; do | |
539 | printf "$1" | tr 'a-z' 'A-Z' | |
540 | printf "\t\"true\";\n" | |
541 | shift | |
542 | done | |
543 | for h in 'MD5' 'SHA1' 'SHA256' 'SHA512'; do | |
544 | printf "$h\t\"false\";\n" | |
545 | done | |
546 | } | awk '!x[$1]++' | |
547 | echo '};' | |
548 | } >> "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/ftparchive-hashes.conf" | |
549 | } | |
5f982b9d DK |
550 | forcecompressor() { |
551 | COMPRESSOR="$1" | |
912a6131 | 552 | COMPRESS="$1" |
5f982b9d DK |
553 | COMPRESSOR_CMD="$1" |
554 | case $COMPRESSOR in | |
555 | gzip) COMPRESS='gz';; | |
556 | bzip2) COMPRESS='bz2';; | |
5f982b9d DK |
557 | esac |
558 | local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor" | |
559 | echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; }; | |
912a6131 DK |
560 | Dir::Bin::uncompressed \"/does/not/exist\";" > "$CONFFILE" |
561 | for COMP in $(aptconfig dump APT::Compressor --format '%t %v%n' | sed -n 's#^Name \([^.].\+\)$#\1#p'); do | |
562 | echo "Dir::Bin::${COMP} \"/does/not/exist\";" | |
563 | done >> "$CONFFILE" | |
5f982b9d DK |
564 | if [ -e "/bin/${COMPRESSOR}" ]; then |
565 | echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE" | |
566 | elif [ -e "/usr/bin/${COMPRESSOR}" ]; then | |
567 | echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE" | |
568 | elif [ "${COMPRESSOR}" = 'lzma' ]; then | |
569 | echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE" | |
570 | COMPRESSOR_CMD='xz --format=lzma' | |
571 | else | |
572 | msgtest 'Test for availability of compressor' "${COMPRESSOR}" | |
68042532 | 573 | msgfail "${COMPRESSOR} not available" |
5f982b9d DK |
574 | fi |
575 | } | |
576 | ||
75954ae2 | 577 | setupsimplenativepackage() { |
ce9864a8 DK |
578 | local NAME="$1" |
579 | local ARCH="$2" | |
580 | local VERSION="$3" | |
581 | local RELEASE="${4:-unstable}" | |
582 | local DEPENDENCIES="$5" | |
14109555 | 583 | local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE} |
18908589 DK |
584 | If you find such a package installed on your system, |
585 | something went horribly wrong! They are autogenerated | |
3d284148 | 586 | und used only by testcases and serve no other purpose…"}" |
18908589 | 587 | |
b7899b00 DK |
588 | local SECTION="${7:-others}" |
589 | local DISTSECTION | |
63c71412 | 590 | if [ "$SECTION" = "${SECTION#*/}" ]; then |
b7899b00 DK |
591 | DISTSECTION="main" |
592 | else | |
63c71412 | 593 | DISTSECTION="${SECTION%/*}" |
b7899b00 | 594 | fi |
ce9864a8 DK |
595 | local BUILDDIR=incoming/${NAME}-${VERSION} |
596 | mkdir -p ${BUILDDIR}/debian/source | |
597 | cd ${BUILDDIR} | |
598 | echo "* most suckless software product ever" > FEATURES | |
b7899b00 DK |
599 | test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright |
600 | test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low | |
ce9864a8 DK |
601 | |
602 | * Initial release | |
603 | ||
b7899b00 DK |
604 | -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog |
605 | test -e debian/control || echo "Source: $NAME | |
606 | Section: $SECTION | |
ce9864a8 DK |
607 | Priority: optional |
608 | Maintainer: Joe Sixpack <joe@example.org> | |
609 | Build-Depends: debhelper (>= 7) | |
610 | Standards-Version: 3.9.1 | |
611 | ||
875bcb36 DK |
612 | Package: $NAME" > debian/control |
613 | if [ "$ARCH" = 'all' ]; then | |
614 | echo "Architecture: all" >> debian/control | |
615 | else | |
616 | echo "Architecture: any" >> debian/control | |
617 | fi | |
ce9864a8 | 618 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control |
18908589 DK |
619 | echo "Description: $DESCRIPTION" >> debian/control |
620 | ||
b7899b00 DK |
621 | test -e debian/compat || echo "7" > debian/compat |
622 | test -e debian/source/format || echo "3.0 (native)" > debian/source/format | |
ce9864a8 | 623 | test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules |
75954ae2 DK |
624 | cd - > /dev/null |
625 | } | |
626 | ||
627 | buildsimplenativepackage() { | |
628 | local NAME="$1" | |
d56e2917 DK |
629 | local NM |
630 | if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then | |
631 | NM="$(echo "$NAME" | cut -c 1-4)" | |
632 | else | |
633 | NM="$(echo "$NAME" | cut -c 1)" | |
634 | fi | |
75954ae2 DK |
635 | local ARCH="$2" |
636 | local VERSION="$3" | |
637 | local RELEASE="${4:-unstable}" | |
638 | local DEPENDENCIES="$5" | |
14109555 | 639 | local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE} |
18908589 DK |
640 | If you find such a package installed on your system, |
641 | something went horribly wrong! They are autogenerated | |
3d284148 | 642 | und used only by testcases and serve no other purpose…"}" |
18908589 | 643 | |
75954ae2 | 644 | local SECTION="${7:-others}" |
d67004e0 | 645 | local PRIORITY="${8:-optional}" |
63c71412 DK |
646 | local FILE_TREE="$9" |
647 | local COMPRESS_TYPE="${10:-gzip}" | |
75954ae2 | 648 | local DISTSECTION |
63c71412 | 649 | if [ "$SECTION" = "${SECTION#*/}" ]; then |
75954ae2 DK |
650 | DISTSECTION="main" |
651 | else | |
63c71412 | 652 | DISTSECTION="${SECTION%/*}" |
75954ae2 | 653 | fi |
63c71412 | 654 | local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}" |
b761356f | 655 | |
0c787570 | 656 | msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME" |
63c71412 DK |
657 | mkdir -p "$BUILDDIR/debian/source" |
658 | echo "* most suckless software product ever" > "${BUILDDIR}/FEATURES" | |
b761356f | 659 | echo "#!/bin/sh |
63c71412 | 660 | echo '$NAME says \"Hello!\"'" > "${BUILDDIR}/${NAME}" |
b761356f | 661 | |
63c71412 | 662 | echo "Copyleft by Joe Sixpack $(date +%Y)" > "${BUILDDIR}/debian/copyright" |
b761356f DK |
663 | echo "$NAME ($VERSION) $RELEASE; urgency=low |
664 | ||
665 | * Initial release | |
666 | ||
63c71412 DK |
667 | -- Joe Sixpack <joe@example.org> $(date -R)" > "${BUILDDIR}/debian/changelog" |
668 | { | |
669 | echo "Source: $NAME | |
d67004e0 | 670 | Priority: $PRIORITY |
b761356f | 671 | Maintainer: Joe Sixpack <joe@example.org> |
63c71412 DK |
672 | Standards-Version: 3.9.3" |
673 | if [ "$SECTION" != '<none>' ]; then | |
674 | echo "Section: $SECTION" | |
675 | fi | |
676 | local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')" | |
677 | test -z "$BUILDDEPS" || echo "$BUILDDEPS" | |
678 | echo " | |
679 | Package: $NAME" | |
b761356f | 680 | |
63c71412 DK |
681 | if [ "$ARCH" = 'all' ]; then |
682 | echo "Architecture: all" | |
683 | else | |
684 | echo "Architecture: any" | |
685 | fi | |
686 | local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')" | |
687 | test -z "$DEPS" || echo "$DEPS" | |
688 | echo "Description: $DESCRIPTION" | |
689 | } > "${BUILDDIR}/debian/control" | |
01f520ce | 690 | |
63c71412 DK |
691 | echo '3.0 (native)' > "${BUILDDIR}/debian/source/format" |
692 | cd "${BUILDDIR}/.." | |
0c787570 DK |
693 | testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION} |
694 | cd - >/dev/null | |
63c71412 | 695 | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" \ |
f1828b69 | 696 | | while read SRC; do |
63c71412 | 697 | echo "pool/${SRC}" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist" |
f1828b69 | 698 | # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then |
33a22672 | 699 | # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \ |
bd7fb5aa | 700 | # adv --yes --default-key 'Joe Sixpack' \ |
f1828b69 DK |
701 | # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC" |
702 | # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC" | |
703 | # fi | |
b761356f | 704 | done |
84aa13f4 | 705 | |
3dcdc1f9 | 706 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do |
0c787570 | 707 | msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME" |
63c71412 DK |
708 | rm -rf "${BUILDDIR}/debian/tmp" |
709 | mkdir -p "${BUILDDIR}/debian/tmp/DEBIAN" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin" | |
710 | cp "${BUILDDIR}/debian/copyright" "${BUILDDIR}/debian/changelog" "${BUILDDIR}/FEATURES" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" | |
711 | cp "${BUILDDIR}/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}" | |
42c1513b | 712 | if [ -n "$FILE_TREE" ]; then |
63c71412 | 713 | cp -ar "$FILE_TREE" "${BUILDDIR}/debian/tmp" |
42c1513b | 714 | fi |
42c1513b | 715 | |
63c71412 DK |
716 | (cd "${BUILDDIR}"; dpkg-gencontrol -DArchitecture=$arch) |
717 | (cd "${BUILDDIR}/debian/tmp"; md5sum $(find usr/ -type f) > DEBIAN/md5sums) | |
846856f4 | 718 | local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log" |
d56e2917 | 719 | # ensure the right permissions as dpkg-deb insists |
63c71412 DK |
720 | chmod 755 "${BUILDDIR}/debian/tmp/DEBIAN" |
721 | testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build "${BUILDDIR}/debian/tmp" "${BUILDDIR}/.." | |
722 | echo "pool/${NAME}_${VERSION}_${arch}.deb" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist" | |
84aa13f4 DK |
723 | done |
724 | ||
d56e2917 | 725 | local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}" |
63c71412 DK |
726 | mkdir -p "$CHANGEPATH" |
727 | cp "${BUILDDIR}/debian/changelog" "$CHANGEPATH" | |
5a635ee4 | 728 | rm -rf "${BUILDDIR}" |
b761356f | 729 | msgdone "info" |
75954ae2 DK |
730 | } |
731 | ||
732 | buildpackage() { | |
733 | local BUILDDIR=$1 | |
734 | local RELEASE=$2 | |
735 | local SECTION=$3 | |
ea65d079 | 736 | local ARCH=$(getarchitecture $4) |
846856f4 DK |
737 | local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')" |
738 | local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")" | |
0c787570 | 739 | msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME" |
63c71412 | 740 | cd "$BUILDDIR" |
75954ae2 DK |
741 | if [ "$ARCH" = "all" ]; then |
742 | ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)" | |
743 | fi | |
0c787570 | 744 | testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH |
63c71412 DK |
745 | cp "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$BUILDLOG" |
746 | local PKGS="$(grep '^dpkg-deb: building package' "$BUILDLOG" | cut -d'/' -f 2 | sed -e "s#'\.##")" | |
747 | local SRCS="$(grep '^dpkg-source: info: building' "$BUILDLOG" | grep -o '[a-z0-9._+~-]*$')" | |
ce9864a8 | 748 | cd - > /dev/null |
b7899b00 | 749 | for PKG in $PKGS; do |
63c71412 | 750 | echo "pool/${PKG}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist" |
b7899b00 DK |
751 | done |
752 | for SRC in $SRCS; do | |
63c71412 | 753 | echo "pool/${SRC}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist" |
b7899b00 | 754 | done |
ce9864a8 DK |
755 | } |
756 | ||
757 | buildaptarchive() { | |
ce9864a8 | 758 | if [ -d incoming ]; then |
846856f4 | 759 | buildaptarchivefromincoming "$@" |
ce9864a8 | 760 | else |
846856f4 | 761 | buildaptarchivefromfiles "$@" |
ce9864a8 DK |
762 | fi |
763 | } | |
764 | ||
765 | createaptftparchiveconfig() { | |
63c71412 | 766 | local COMPRESSORS="$(cut -d' ' -f 1 "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | tr '\n' ' ')" |
016bea82 DK |
767 | local COMPRESSORS="${COMPRESSORS%* }" |
768 | local ARCHS="$(getarchitectures)" | |
c5ede4ca DK |
769 | cat > ftparchive.conf <<EOF |
770 | Dir { | |
771 | ArchiveDir "$(readlink -f .)"; | |
772 | CacheDir "$(readlink -f ..)"; | |
773 | FileListDir "$(readlink -f pool/)"; | |
b7899b00 DK |
774 | }; |
775 | Default { | |
c5ede4ca DK |
776 | Packages::Compress "$COMPRESSORS"; |
777 | Sources::Compress "$COMPRESSORS"; | |
778 | Contents::Compress "$COMPRESSORS"; | |
779 | Translation::Compress "$COMPRESSORS"; | |
18331adf | 780 | LongDescription "false"; |
ce9864a8 DK |
781 | }; |
782 | TreeDefault { | |
783 | Directory "pool/"; | |
784 | SrcDirectory "pool/"; | |
785 | }; | |
c5ede4ca | 786 | EOF |
b7899b00 | 787 | for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do |
63c71412 DK |
788 | cat <<EOF |
789 | tree "dists/$DIST" { | |
1dd20368 | 790 | Architectures "$ARCHS all source"; |
63c71412 DK |
791 | FileList "${DIST}.\$(SECTION).pkglist"; |
792 | SourceFileList "${DIST}.\$(SECTION).srclist"; | |
793 | Sections "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')"; | |
794 | }; | |
795 | EOF | |
796 | done >> ftparchive.conf | |
ce9864a8 DK |
797 | } |
798 | ||
799 | buildaptftparchivedirectorystructure() { | |
b7899b00 DK |
800 | local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')" |
801 | for DIST in $DISTS; do | |
802 | local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)" | |
803 | for SECTION in $SECTIONS; do | |
804 | local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')" | |
805 | for ARCH in $ARCHS; do | |
63c71412 | 806 | mkdir -p "dists/${DIST}/${SECTION}/binary-${ARCH}" |
b7899b00 | 807 | done |
63c71412 DK |
808 | mkdir -p "dists/${DIST}/${SECTION}/source" |
809 | mkdir -p "dists/${DIST}/${SECTION}/i18n" | |
b7899b00 | 810 | done |
ce9864a8 | 811 | done |
ce9864a8 DK |
812 | } |
813 | ||
9b78cda6 | 814 | insertpackage() { |
10e100e5 | 815 | local RELEASES="$1" |
9b78cda6 DK |
816 | local NAME="$2" |
817 | local ARCH="$3" | |
818 | local VERSION="$4" | |
819 | local DEPENDENCIES="$5" | |
d67004e0 | 820 | local PRIORITY="${6:-optional}" |
10e100e5 | 821 | local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES} |
18908589 DK |
822 | If you find such a package installed on your system, |
823 | something went horribly wrong! They are autogenerated | |
3d284148 | 824 | und used only by testcases and serve no other purpose…"}" |
d67004e0 | 825 | local ARCHS="" |
10e100e5 DK |
826 | for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do |
827 | if [ "$RELEASE" = 'installed' ]; then | |
828 | insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7" | |
829 | continue | |
d67004e0 | 830 | fi |
10e100e5 | 831 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do |
1dd20368 | 832 | if [ "$arch" = 'none' ]; then |
10e100e5 DK |
833 | ARCHS="$(getarchitectures)" |
834 | else | |
835 | ARCHS="$arch" | |
836 | fi | |
837 | for BUILDARCH in $ARCHS; do | |
838 | local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}" | |
63c71412 DK |
839 | mkdir -p "$PPATH" |
840 | { | |
841 | echo "Package: $NAME | |
d67004e0 | 842 | Priority: $PRIORITY |
9b78cda6 | 843 | Section: other |
2c085486 | 844 | Installed-Size: 42 |
63c71412 DK |
845 | Maintainer: Joe Sixpack <joe@example.org>" |
846 | test "$arch" = 'none' || echo "Architecture: $arch" | |
847 | echo "Version: $VERSION | |
848 | Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" | |
849 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" | |
850 | echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)" | |
851 | echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)" | |
852 | echo | |
853 | } >> "${PPATH}/Packages" | |
10e100e5 | 854 | done |
d67004e0 | 855 | done |
63c71412 DK |
856 | mkdir -p "aptarchive/dists/${RELEASE}/main/source" "aptarchive/dists/${RELEASE}/main/i18n" |
857 | touch "aptarchive/dists/${RELEASE}/main/source/Sources" | |
10e100e5 | 858 | echo "Package: $NAME |
0e0d9919 DK |
859 | Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1) |
860 | Description-en: $DESCRIPTION | |
63c71412 | 861 | " >> "aptarchive/dists/${RELEASE}/main/i18n/Translation-en" |
10e100e5 | 862 | done |
9b78cda6 DK |
863 | } |
864 | ||
234675b7 DK |
865 | insertsource() { |
866 | local RELEASE="$1" | |
867 | local NAME="$2" | |
868 | local ARCH="$3" | |
869 | local VERSION="$4" | |
870 | local DEPENDENCIES="$5" | |
a8275acf | 871 | local BINARY="${6:-$NAME}" |
234675b7 DK |
872 | local ARCHS="" |
873 | local SPATH="aptarchive/dists/${RELEASE}/main/source" | |
874 | mkdir -p $SPATH | |
875 | local FILE="${SPATH}/Sources" | |
9d2a8a73 DK |
876 | local DSCFILE="${NAME}_${VERSION}.dsc" |
877 | local TARFILE="${NAME}_${VERSION}.tar.gz" | |
234675b7 | 878 | echo "Package: $NAME |
a8275acf | 879 | Binary: $BINARY |
234675b7 DK |
880 | Version: $VERSION |
881 | Maintainer: Joe Sixpack <joe@example.org> | |
882 | Architecture: $ARCH" >> $FILE | |
63c71412 | 883 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE" |
234675b7 | 884 | echo "Files: |
63c71412 DK |
885 | $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE" |
886 | $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE" | |
55ae7a51 | 887 | Checksums-Sha256: |
63c71412 DK |
888 | $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE" |
889 | $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE" | |
890 | " >> "$FILE" | |
234675b7 DK |
891 | } |
892 | ||
dfc2b1be DK |
893 | insertinstalledpackage() { |
894 | local NAME="$1" | |
895 | local ARCH="$2" | |
896 | local VERSION="$3" | |
897 | local DEPENDENCIES="$4" | |
d67004e0 | 898 | local PRIORITY="${5:-optional}" |
d4b4e5ea | 899 | local STATUS="${6:-install ok installed}" |
14109555 | 900 | local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed |
18908589 DK |
901 | If you find such a package installed on your system, |
902 | something went horribly wrong! They are autogenerated | |
3d284148 | 903 | und used only by testcases and serve no other purpose…"}" |
18908589 | 904 | |
53ea1b56 DK |
905 | local FILE='rootdir/var/lib/dpkg/status' |
906 | local INFO='rootdir/var/lib/dpkg/info' | |
3dcdc1f9 | 907 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do |
d67004e0 | 908 | echo "Package: $NAME |
d4b4e5ea | 909 | Status: $STATUS |
d67004e0 | 910 | Priority: $PRIORITY |
dfc2b1be DK |
911 | Section: other |
912 | Installed-Size: 42 | |
913 | Maintainer: Joe Sixpack <joe@example.org> | |
63c71412 DK |
914 | Version: $VERSION" >> "$FILE" |
915 | test "$arch" = 'none' || echo "Architecture: $arch" >> "$FILE" | |
916 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE" | |
917 | echo "Description: $DESCRIPTION" >> "$FILE" | |
918 | echo >> "$FILE" | |
53ea1b56 | 919 | if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then |
63c71412 | 920 | echo -n > "${INFO}/${NAME}:${arch}.list" |
53ea1b56 | 921 | else |
63c71412 | 922 | echo -n > "${INFO}/${NAME}.list" |
53ea1b56 | 923 | fi |
d67004e0 | 924 | done |
dfc2b1be DK |
925 | } |
926 | ||
927 | ||
ce9864a8 | 928 | buildaptarchivefromincoming() { |
63c71412 | 929 | msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on incoming packages…" |
ce9864a8 DK |
930 | cd aptarchive |
931 | [ -e pool ] || ln -s ../incoming pool | |
932 | [ -e ftparchive.conf ] || createaptftparchiveconfig | |
933 | [ -e dists ] || buildaptftparchivedirectorystructure | |
b7899b00 | 934 | msgninfo "\tGenerate Packages, Sources and Contents files… " |
31be38d2 | 935 | testsuccess aptftparchive generate ftparchive.conf |
ce9864a8 DK |
936 | cd - > /dev/null |
937 | msgdone "info" | |
4dbfe436 | 938 | generatereleasefiles "$@" |
ce9864a8 DK |
939 | } |
940 | ||
941 | buildaptarchivefromfiles() { | |
63c71412 | 942 | msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on prebuild files…" |
8d041b4f DK |
943 | local DIR='aptarchive' |
944 | if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi | |
945 | find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do | |
9b78cda6 | 946 | msgninfo "\t${line} file… " |
276e51dd | 947 | compressfile "$line" "$1" |
8d876415 | 948 | msgdone "info" |
9b78cda6 | 949 | done |
e3c62328 | 950 | generatereleasefiles "$@" |
9b78cda6 DK |
951 | } |
952 | ||
276e51dd | 953 | compressfile() { |
63c71412 | 954 | cat "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | while read compressor extension command; do |
276e51dd DK |
955 | if [ "$compressor" = '.' ]; then |
956 | if [ -n "$2" ]; then | |
957 | touch -d "$2" "$1" | |
958 | fi | |
959 | continue | |
960 | fi | |
961 | cat "$1" | $command > "${1}.${extension}" | |
962 | if [ -n "$2" ]; then | |
963 | touch -d "$2" "${1}.${extension}" | |
964 | fi | |
965 | done | |
966 | } | |
967 | ||
a3bbbab7 | 968 | # can be overridden by testcases for their pleasure |
bf9e7447 DK |
969 | getcodenamefromsuite() { |
970 | case "$1" in | |
971 | unstable) echo 'sid';; | |
972 | *) echo -n "$1";; | |
973 | esac | |
974 | } | |
a3bbbab7 | 975 | getreleaseversionfromsuite() { true; } |
718f797c | 976 | getlabelfromsuite() { true; } |
d56e2917 | 977 | getoriginfromsuite() { true; } |
1dd20368 | 978 | getarchitecturesfromreleasefile() { echo "all $(getarchitectures)"; } |
a3bbbab7 | 979 | |
c5ede4ca DK |
980 | aptftparchiverelease() { |
981 | aptftparchive -qq release "$@" | sed -e '/0 Release$/ d' # remove the self reference | |
982 | } | |
9b78cda6 | 983 | generatereleasefiles() { |
884a4c0a DK |
984 | # $1 is the Date header and $2 is the ValidUntil header to be set |
985 | # both should be given in notation date/touch can understand | |
1dd20368 DK |
986 | local DATE="$1" |
987 | local VALIDUNTIL="$2" | |
9b78cda6 | 988 | if [ -e aptarchive/dists ]; then |
87d6947d | 989 | msgninfo "\tGenerate Release files for dists… " |
9b78cda6 | 990 | for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do |
1dd20368 | 991 | local ARCHITECTURES="$(getarchitecturesfromreleasefile "$dir")" |
a3bbbab7 DK |
992 | local SUITE="$(echo "$dir" | cut -d'/' -f 4)" |
993 | local CODENAME="$(getcodenamefromsuite $SUITE)" | |
994 | local VERSION="$(getreleaseversionfromsuite $SUITE)" | |
718f797c | 995 | local LABEL="$(getlabelfromsuite $SUITE)" |
d56e2917 | 996 | local ORIGIN="$(getoriginfromsuite $SUITE)" |
63c71412 | 997 | aptftparchiverelease "$dir" \ |
884a4c0a DK |
998 | -o APT::FTPArchive::Release::Suite="${SUITE}" \ |
999 | -o APT::FTPArchive::Release::Codename="${CODENAME}" \ | |
bc7a59dd DK |
1000 | -o APT::FTPArchive::Release::Architectures="${ARCHITECTURES}" \ |
1001 | -o APT::FTPArchive::Release::Label="${LABEL}" \ | |
1002 | -o APT::FTPArchive::Release::Origin="${ORIGIN}" \ | |
1003 | -o APT::FTPArchive::Release::Version="${VERSION}" \ | |
63c71412 | 1004 | > "$dir/Release" |
a3bbbab7 | 1005 | if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then |
35faae11 | 1006 | sed -i '/^Date: / a\ |
63c71412 | 1007 | NotAutomatic: yes' "$dir/Release" |
35faae11 | 1008 | fi |
9b78cda6 DK |
1009 | done |
1010 | else | |
87d6947d | 1011 | msgninfo "\tGenerate Release files for flat… " |
c5ede4ca | 1012 | aptftparchiverelease ./aptarchive > aptarchive/Release |
8d876415 | 1013 | fi |
1dd20368 | 1014 | if [ -n "$DATE" -a "$DATE" != "now" ]; then |
fe0f7911 | 1015 | for release in $(find ./aptarchive -name 'Release'); do |
1dd20368 DK |
1016 | sed -i "s/^Date: .*$/Date: $(date -d "$DATE" '+%a, %d %b %Y %H:%M:%S %Z')/" "$release" |
1017 | touch -d "$DATE" "$release" | |
fe0f7911 | 1018 | done |
8d876415 | 1019 | fi |
1dd20368 | 1020 | if [ -n "$VALIDUNTIL" ]; then |
c5ede4ca | 1021 | sed -i "/^Date: / a\ |
1dd20368 | 1022 | Valid-Until: $(date -d "$VALIDUNTIL" '+%a, %d %b %Y %H:%M:%S %Z')" $(find ./aptarchive -name 'Release') |
c5ede4ca | 1023 | fi |
b7899b00 | 1024 | msgdone "info" |
8d876415 DK |
1025 | } |
1026 | ||
b7899b00 | 1027 | setupdistsaptarchive() { |
63c71412 | 1028 | local APTARCHIVE="$(readlink -f ./aptarchive | sed 's# #%20#g')" |
b7899b00 DK |
1029 | rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list |
1030 | rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list | |
1031 | for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do | |
63c71412 | 1032 | SECTIONS=$(find "./aptarchive/dists/${DISTS}/" -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ') |
b7899b00 | 1033 | msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… " |
63c71412 DK |
1034 | echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list" |
1035 | echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list" | |
b7899b00 DK |
1036 | msgdone "info" |
1037 | done | |
1038 | } | |
1039 | ||
1040 | setupflataptarchive() { | |
63c71412 DK |
1041 | local APTARCHIVE="$(readlink -f ./aptarchive)" |
1042 | local APTARCHIVEURI="$(readlink -f ./aptarchive | sed 's# #%20#g')" | |
1043 | if [ -f "${APTARCHIVE}/Packages" ]; then | |
8d876415 | 1044 | msgninfo "\tadd deb sources.list line… " |
63c71412 DK |
1045 | echo "deb file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list' |
1046 | msgdone 'info' | |
8d876415 | 1047 | else |
63c71412 | 1048 | rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list' |
8d876415 | 1049 | fi |
63c71412 | 1050 | if [ -f "${APTARCHIVE}/Sources" ]; then |
8d876415 | 1051 | msgninfo "\tadd deb-src sources.list line… " |
63c71412 DK |
1052 | echo "deb-src file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list' |
1053 | msgdone 'info' | |
8d876415 | 1054 | else |
63c71412 | 1055 | rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list' |
8d876415 | 1056 | fi |
b7899b00 DK |
1057 | } |
1058 | ||
1059 | setupaptarchive() { | |
4dbfe436 DK |
1060 | local NOUPDATE=0 |
1061 | if [ "$1" = '--no-update' ]; then | |
1062 | NOUPDATE=1 | |
1063 | shift | |
1064 | fi | |
1065 | buildaptarchive "$@" | |
b7899b00 DK |
1066 | if [ -e aptarchive/dists ]; then |
1067 | setupdistsaptarchive | |
1068 | else | |
1069 | setupflataptarchive | |
1070 | fi | |
9d653a6d | 1071 | signreleasefiles 'Joe Sixpack' |
4dbfe436 | 1072 | if [ "1" != "$NOUPDATE" ]; then |
5684f71f | 1073 | testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true |
b2ea1a47 | 1074 | fi |
8d876415 DK |
1075 | } |
1076 | ||
f213b6ea DK |
1077 | signreleasefiles() { |
1078 | local SIGNER="${1:-Joe Sixpack}" | |
07cb47e7 | 1079 | local REPODIR="${2:-aptarchive}" |
f1e1abd8 | 1080 | local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')" |
33a22672 | 1081 | local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes" |
f1e1abd8 | 1082 | msgninfo "\tSign archive with $SIGNER key $KEY… " |
29a59c46 DK |
1083 | local REXKEY='keys/rexexpired' |
1084 | local SECEXPIREBAK="${REXKEY}.sec.bak" | |
1085 | local PUBEXPIREBAK="${REXKEY}.pub.bak" | |
1086 | if [ "${SIGNER}" = 'Rex Expired' ]; then | |
1087 | # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time | |
1088 | # option doesn't exist anymore (and using faketime would add a new obscure dependency) | |
1089 | # therefore we 'temporary' make the key not expired and restore a backup after signing | |
63c71412 DK |
1090 | cp "${REXKEY}.sec" "$SECEXPIREBAK" |
1091 | cp "${REXKEY}.pub" "$PUBEXPIREBAK" | |
29a59c46 DK |
1092 | local SECUNEXPIRED="${REXKEY}.sec.unexpired" |
1093 | local PUBUNEXPIRED="${REXKEY}.pub.unexpired" | |
1094 | if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then | |
63c71412 DK |
1095 | cp "$SECUNEXPIRED" "${REXKEY}.sec" |
1096 | cp "$PUBUNEXPIRED" "${REXKEY}.pub" | |
29a59c46 | 1097 | else |
f1e1abd8 DK |
1098 | if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then |
1099 | cat setexpire.gpg | |
1100 | exit 1 | |
1101 | fi | |
63c71412 DK |
1102 | cp "${REXKEY}.sec" "$SECUNEXPIRED" |
1103 | cp "${REXKEY}.pub" "$PUBUNEXPIRED" | |
29a59c46 DK |
1104 | fi |
1105 | fi | |
63c71412 | 1106 | for RELEASE in $(find "${REPODIR}/" -name Release); do |
785cb6fc | 1107 | testsuccess $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output "${RELEASE}.gpg" "${RELEASE}" |
e3c62328 | 1108 | local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" |
785cb6fc | 1109 | testsuccess $GPG --default-key "$SIGNER" --clearsign --output "$INRELEASE" "$RELEASE" |
e3c62328 | 1110 | # we might have set a specific date for the Release file, so copy it |
63c71412 | 1111 | touch -d "$(stat --format "%y" ${RELEASE})" "${RELEASE}.gpg" "${INRELEASE}" |
f213b6ea | 1112 | done |
29a59c46 | 1113 | if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then |
63c71412 DK |
1114 | mv -f "$SECEXPIREBAK" "${REXKEY}.sec" |
1115 | mv -f "$PUBEXPIREBAK" "${REXKEY}.pub" | |
29a59c46 | 1116 | fi |
63c71412 | 1117 | msgdone 'info' |
f213b6ea DK |
1118 | } |
1119 | ||
8eafc759 DK |
1120 | redatereleasefiles() { |
1121 | local DATE="$(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')" | |
1122 | for release in $(find aptarchive/ -name 'Release'); do | |
63c71412 DK |
1123 | sed -i "s/^Date: .*$/Date: ${DATE}/" "$release" |
1124 | touch -d "$DATE" "$release" | |
8eafc759 DK |
1125 | done |
1126 | signreleasefiles "${2:-Joe Sixpack}" | |
1127 | } | |
1128 | ||
f2c0ec8b | 1129 | webserverconfig() { |
6c0765c0 | 1130 | local WEBSERVER="${3:-http://localhost:${APTHTTPPORT}}" |
b0314abb DK |
1131 | local NOCHECK=false |
1132 | if [ "$1" = '--no-check' ]; then | |
1133 | NOCHECK=true | |
1134 | shift | |
1135 | fi | |
0d58c26a | 1136 | local DOWNLOG='rootdir/tmp/download-testfile.log' |
b0314abb | 1137 | local STATUS='downloaded/webserverconfig.status' |
0d58c26a | 1138 | rm -f "$STATUS" "$DOWNLOG" |
6c0765c0 | 1139 | # very very basic URI encoding |
b0314abb DK |
1140 | local URI |
1141 | if [ -n "$2" ]; then | |
1142 | msgtest "Set webserver config option '${1}' to" "$2" | |
6c0765c0 | 1143 | URI="${WEBSERVER}/_config/set/$(echo "${1}" | sed -e 's/\//%2f/g')/$(echo "${2}" | sed -e 's/\//%2f/g')" |
b0314abb DK |
1144 | else |
1145 | msgtest 'Clear webserver config option' "${1}" | |
6c0765c0 | 1146 | URI="${WEBSERVER}/_config/clear/$(echo "${1}" | sed -e 's/\//%2f/g')" |
b0314abb DK |
1147 | fi |
1148 | if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then | |
f2c0ec8b DK |
1149 | msgpass |
1150 | else | |
68042532 DK |
1151 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output" |
1152 | cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true | |
1153 | msgfailoutput '' "$OUTPUT" | |
f2c0ec8b | 1154 | fi |
b0314abb | 1155 | $NOCHECK || testwebserverlaststatuscode '200' |
f2c0ec8b DK |
1156 | } |
1157 | ||
fd46d305 | 1158 | rewritesourceslist() { |
63c71412 | 1159 | local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')" |
af9e40c9 | 1160 | local APTARCHIVE2="copy://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')" |
fd46d305 | 1161 | for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do |
af9e40c9 DK |
1162 | sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#$APTARCHIVE2#${1}#" \ |
1163 | -e "s#http://localhost:${APTHTTPPORT}/#${1}#" \ | |
1164 | -e "s#https://localhost:${APTHTTPSPORT}/#${1}#" | |
fd46d305 DK |
1165 | done |
1166 | } | |
1167 | ||
5572f6bd MV |
1168 | # wait for up to 10s for a pid file to appear to avoid possible race |
1169 | # when a helper is started and dosn't write the PID quick enough | |
1170 | waitforpidfile() { | |
1171 | local PIDFILE="$1" | |
1172 | for i in $(seq 10); do | |
1173 | if test -s "$PIDFILE"; then | |
1174 | return 0 | |
1175 | fi | |
1176 | sleep 1 | |
1177 | done | |
1178 | msgdie "waiting for $PIDFILE failed" | |
1179 | return 1 | |
1180 | } | |
1181 | ||
f213b6ea | 1182 | changetowebserver() { |
6c0765c0 | 1183 | local REWRITE='no' |
23af9f40 | 1184 | if [ "$1" != '--no-rewrite' ]; then |
6c0765c0 | 1185 | REWRITE='yes' |
23af9f40 DK |
1186 | else |
1187 | shift | |
1188 | fi | |
63c71412 | 1189 | if test -x "${APTWEBSERVERBINDIR}/aptwebserver"; then |
fbd29dd6 | 1190 | cd aptarchive |
a0db467c | 1191 | local LOG="webserver.log" |
6c0765c0 | 1192 | if ! aptwebserver --port 0 -o aptwebserver::fork=1 -o aptwebserver::portfile='aptwebserver.port' "$@" >$LOG 2>&1 ; then |
3abb6a6a | 1193 | cat "$LOG" |
bee0670b DK |
1194 | false |
1195 | fi | |
6c0765c0 | 1196 | waitforpidfile aptwebserver.pid |
e3c62328 DK |
1197 | local PID="$(cat aptwebserver.pid)" |
1198 | if [ -z "$PID" ]; then | |
1199 | msgdie 'Could not fork aptwebserver successfully' | |
1200 | fi | |
1201 | addtrap "kill $PID;" | |
6c0765c0 DK |
1202 | waitforpidfile aptwebserver.port |
1203 | APTHTTPPORT="$(cat aptwebserver.port)" | |
1204 | if [ -z "$APTHTTPPORT" ]; then | |
1205 | msgdie 'Could not get port for aptwebserver successfully' | |
1206 | fi | |
fbd29dd6 | 1207 | cd - > /dev/null |
c5bcc607 | 1208 | else |
3d284148 | 1209 | msgdie 'You have to build apt from source to have test/interactive-helper/aptwebserver available for tests requiring a webserver' |
f213b6ea | 1210 | fi |
6c0765c0 DK |
1211 | if [ "$REWRTE" != 'yes' ]; then |
1212 | rewritesourceslist "http://localhost:${APTHTTPPORT}/" | |
1213 | fi | |
fd46d305 DK |
1214 | } |
1215 | ||
1216 | changetohttpswebserver() { | |
e75e5879 | 1217 | if ! command -v stunnel4 >/dev/null 2>&1; then |
fd46d305 DK |
1218 | msgdie 'You need to install stunnel4 for https testcases' |
1219 | fi | |
1220 | if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then | |
dc95fee1 | 1221 | changetowebserver --no-rewrite "$@" |
fd46d305 DK |
1222 | fi |
1223 | echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid | |
68ba0b7f | 1224 | cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem |
23af9f40 | 1225 | output = /dev/null |
fd46d305 DK |
1226 | |
1227 | [https] | |
6c0765c0 DK |
1228 | accept = 0 |
1229 | connect = $APTHTTPPORT | |
63c71412 | 1230 | " > "${TMPWORKINGDIRECTORY}/stunnel.conf" |
fd46d305 | 1231 | stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf" |
5572f6bd | 1232 | waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid" |
63c71412 | 1233 | local PID="$(cat "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid")" |
5572f6bd MV |
1234 | if [ -z "$PID" ]; then |
1235 | msgdie 'Could not fork stunnel4 successfully' | |
1236 | fi | |
fd46d305 | 1237 | addtrap 'prefix' "kill ${PID};" |
6c0765c0 DK |
1238 | APTHTTPSPORT="$(lsof -i | awk "/^stunnel4 / && \$2 == \"${PID}\" {print \$9; exit; }" | cut -d':' -f 2)" |
1239 | webserverconfig 'aptwebserver::port::https' "$APTHTTPSPORT" "https://localhost:${APTHTTPSPORT}" | |
1240 | rewritesourceslist "https://localhost:${APTHTTPSPORT}/" | |
f213b6ea DK |
1241 | } |
1242 | ||
c45233ea DK |
1243 | changetocdrom() { |
1244 | mkdir -p rootdir/media/cdrom/.disk | |
1245 | local CD="$(readlink -f rootdir/media/cdrom)" | |
63c71412 DK |
1246 | cat > rootdir/etc/apt/apt.conf.d/00cdrom <<EOF |
1247 | acquire::cdrom::mount "${CD}"; | |
1248 | acquire::cdrom::"${CD}/"::mount "mv ${CD}-unmounted ${CD}"; | |
1249 | acquire::cdrom::"${CD}/"::umount "mv ${CD} ${CD}-unmounted"; | |
1250 | acquire::cdrom::autodetect 0; | |
1251 | EOF | |
1252 | echo -n "$1" > "${CD}/.disk/info" | |
c45233ea DK |
1253 | if [ ! -d aptarchive/dists ]; then |
1254 | msgdie 'Flat file archive cdroms can not be created currently' | |
1255 | return 1 | |
1256 | fi | |
a0975c8d | 1257 | mv aptarchive/dists "$CD" |
63c71412 | 1258 | ln -s "$(readlink -f ./incoming)" "$CD/pool" |
c45233ea | 1259 | find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete |
a0975c8d DK |
1260 | # start with an unmounted disk |
1261 | mv "${CD}" "${CD}-unmounted" | |
1262 | # we don't want the disk to be modifiable | |
bc8f83a5 | 1263 | addtrap 'prefix' "chmod -f -R +w '$(escape_shell "$PWD/rootdir/media/cdrom/dists/")' '$(escape_shell "$PWD/rootdir/media/cdrom-unmounted/dists/")' || true;" |
b0314abb | 1264 | chmod -R 555 rootdir/media/cdrom-unmounted/dists |
c45233ea DK |
1265 | } |
1266 | ||
fd46d305 | 1267 | downloadfile() { |
ed793a19 | 1268 | local PROTO="${1%%:*}" |
27925d82 | 1269 | if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \ |
dcbb364f | 1270 | download-file "$1" "$2" "$3" 2>&1 ; then |
27925d82 DK |
1271 | return 1 |
1272 | fi | |
fd46d305 | 1273 | # only if the file exists the download was successful |
b0314abb | 1274 | if [ -r "$2" ]; then |
fd46d305 DK |
1275 | return 0 |
1276 | else | |
1277 | return 1 | |
1278 | fi | |
1279 | } | |
1280 | ||
f213b6ea | 1281 | checkdiff() { |
03aa0847 | 1282 | local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')" |
8d876415 | 1283 | if [ -n "$DIFFTEXT" ]; then |
0d58c26a DK |
1284 | echo >&2 |
1285 | echo >&2 "$DIFFTEXT" | |
8d876415 DK |
1286 | return 1 |
1287 | else | |
1288 | return 0 | |
1289 | fi | |
1290 | } | |
1291 | ||
22ac12b2 DK |
1292 | testoutputequal() { |
1293 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output" | |
1294 | local COMPAREFILE="$1" | |
1295 | shift | |
63c71412 | 1296 | if "$@" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then |
22ac12b2 DK |
1297 | msgpass |
1298 | else | |
1299 | echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}" | |
1300 | cat "$COMPAREFILE" >>"${OUTPUT}" | |
1301 | msgfailoutput '' "$OUTPUT" "$@" | |
1302 | fi | |
1303 | } | |
1304 | ||
75954ae2 | 1305 | testfileequal() { |
1501a2c9 | 1306 | msggroup 'testfileequal' |
e6a12ff7 DK |
1307 | local MSG='Test for correctness of file' |
1308 | if [ "$1" = '--nomsg' ]; then | |
1309 | MSG='' | |
1310 | shift | |
1311 | fi | |
75954ae2 DK |
1312 | local FILE="$1" |
1313 | shift | |
e6a12ff7 DK |
1314 | if [ -n "$MSG" ]; then |
1315 | msgtest "$MSG" "$FILE" | |
1316 | fi | |
68042532 | 1317 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output" |
75954ae2 | 1318 | if [ -z "$*" ]; then |
22ac12b2 | 1319 | testoutputequal "$FILE" echo -n '' |
75954ae2 | 1320 | else |
22ac12b2 | 1321 | testoutputequal "$FILE" echo "$*" |
75954ae2 | 1322 | fi |
9beb11aa | 1323 | msggroup |
75954ae2 DK |
1324 | } |
1325 | ||
b855a400 | 1326 | testempty() { |
1501a2c9 | 1327 | msggroup 'testempty' |
b855a400 | 1328 | msgtest "Test for no output of" "$*" |
859093da | 1329 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile" |
63c71412 | 1330 | if ("$@" >"$COMPAREFILE" 2>&1 || true) && test ! -s "$COMPAREFILE"; then |
859093da DK |
1331 | msgpass |
1332 | else | |
22ac12b2 | 1333 | msgfailoutput '' "$COMPAREFILE" "$@" |
859093da | 1334 | fi |
ab25bf1f | 1335 | aptautotest 'testempty' "$@" |
9beb11aa | 1336 | msggroup |
b855a400 | 1337 | } |
63c71412 DK |
1338 | testnotempty() { |
1339 | msggroup 'testnotempty' | |
1340 | msgtest "Test for some output of" "$*" | |
1341 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnotempty.comparefile" | |
1342 | if ("$@" >"$COMPAREFILE" 2>&1 || true) && test -s "$COMPAREFILE"; then | |
1343 | msgpass | |
1344 | else | |
1345 | msgfailoutput '' "$COMPAREFILE" "$@" | |
1346 | fi | |
1347 | aptautotest 'testnotempty' "$@" | |
1348 | msggroup | |
1349 | } | |
b855a400 | 1350 | |
f74a6fa1 | 1351 | testequal() { |
1501a2c9 | 1352 | msggroup 'testequal' |
f74a6fa1 DK |
1353 | local MSG='Test of equality of' |
1354 | if [ "$1" = '--nomsg' ]; then | |
1355 | MSG='' | |
1356 | shift | |
1357 | fi | |
1358 | ||
03938280 | 1359 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile" |
63c71412 | 1360 | echo "$1" > "$COMPAREFILE" |
8d876415 | 1361 | shift |
d2d68aaf | 1362 | |
f74a6fa1 DK |
1363 | if [ -n "$MSG" ]; then |
1364 | msgtest "$MSG" "$*" | |
1365 | fi | |
22ac12b2 | 1366 | testoutputequal "$COMPAREFILE" "$@" |
ab25bf1f | 1367 | aptautotest 'testequal' "$@" |
9beb11aa | 1368 | msggroup |
8d876415 DK |
1369 | } |
1370 | ||
685625bd | 1371 | testequalor2() { |
1501a2c9 | 1372 | msggroup 'testequalor2' |
03938280 DK |
1373 | local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1" |
1374 | local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2" | |
1375 | local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst" | |
63c71412 DK |
1376 | echo "$1" > "$COMPAREFILE1" |
1377 | echo "$2" > "$COMPAREFILE2" | |
685625bd DK |
1378 | shift 2 |
1379 | msgtest "Test for equality OR of" "$*" | |
63c71412 DK |
1380 | "$@" >"$COMPAREAGAINST" 2>&1 || true |
1381 | if checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >/dev/null 2>&1 || \ | |
1382 | checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >/dev/null 2>&1 | |
0d58c26a | 1383 | then |
0caa5a4c DK |
1384 | msgpass |
1385 | else | |
68042532 DK |
1386 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output" |
1387 | echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1 | |
1388 | checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true | |
1389 | echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1 | |
1390 | checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true | |
1391 | msgfailoutput '' "$OUTPUT" | |
0caa5a4c | 1392 | fi |
ab25bf1f | 1393 | aptautotest 'testequalor2' "$@" |
9beb11aa | 1394 | msggroup |
685625bd DK |
1395 | } |
1396 | ||
8d876415 | 1397 | testshowvirtual() { |
1501a2c9 | 1398 | msggroup 'testshowvirtual' |
edc0ef10 | 1399 | local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual" |
8d876415 DK |
1400 | local PACKAGE="$1" |
1401 | shift | |
1402 | while [ -n "$1" ]; do | |
1403 | VIRTUAL="${VIRTUAL} | |
edc0ef10 | 1404 | N: Can't select versions from package '$1' as it is purely virtual" |
8d876415 DK |
1405 | PACKAGE="${PACKAGE} $1" |
1406 | shift | |
1407 | done | |
1408 | msgtest "Test for virtual packages" "apt-cache show $PACKAGE" | |
1409 | VIRTUAL="${VIRTUAL} | |
4bec02c2 | 1410 | N: No packages found" |
03938280 | 1411 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile" |
ea65d079 | 1412 | local ARCH="$(getarchitecture 'native')" |
68042532 DK |
1413 | echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE" |
1414 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output" | |
87d6947d | 1415 | testoutputequal "$COMPAREFILE" aptcache show "$PACKAGE" |
9beb11aa | 1416 | msggroup |
8d876415 DK |
1417 | } |
1418 | ||
1419 | testnopackage() { | |
1501a2c9 | 1420 | msggroup 'testnopackage' |
8d876415 | 1421 | msgtest "Test for non-existent packages" "apt-cache show $*" |
846856f4 | 1422 | local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')" |
8d876415 | 1423 | if [ -n "$SHOWPKG" ]; then |
68042532 DK |
1424 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output" |
1425 | echo "$SHOWPKG" >"$OUTPUT" | |
1426 | msgfailoutput '' "$OUTPUT" | |
0d58c26a DK |
1427 | else |
1428 | msgpass | |
8d876415 | 1429 | fi |
9beb11aa | 1430 | msggroup |
8d876415 | 1431 | } |
bd4a8f51 DK |
1432 | testnosrcpackage() { |
1433 | msggroup 'testnosrcpackage' | |
1434 | msgtest "Test for non-existent source packages" "apt-cache showsrc $*" | |
1435 | local SHOWPKG="$(aptcache showsrc "$@" 2>&1 | grep '^Package: ')" | |
1436 | if [ -n "$SHOWPKG" ]; then | |
1437 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnosrcpackage.output" | |
1438 | echo "$SHOWPKG" >"$OUTPUT" | |
1439 | msgfailoutput '' "$OUTPUT" | |
1440 | else | |
1441 | msgpass | |
1442 | fi | |
1443 | msggroup | |
1444 | } | |
01a6e24c | 1445 | |
ecb777dd | 1446 | testdpkgstatus() { |
1501a2c9 | 1447 | msggroup 'testdpkgstatus' |
ecb777dd DK |
1448 | local STATE="$1" |
1449 | local NR="$2" | |
1450 | shift 2 | |
1451 | msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*" | |
1452 | local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)" | |
1453 | if [ "$PKGS" != $NR ]; then | |
68042532 DK |
1454 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output" |
1455 | echo "$PKGS" >"$OUTPUT" | |
1456 | dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true | |
1457 | msgfailoutput '' "$OUTPUT" | |
0d58c26a DK |
1458 | else |
1459 | msgpass | |
01a6e24c | 1460 | fi |
9beb11aa | 1461 | msggroup |
01a6e24c DK |
1462 | } |
1463 | ||
ecb777dd | 1464 | testdpkginstalled() { |
1501a2c9 | 1465 | msggroup 'testdpkginstalled' |
ecb777dd | 1466 | testdpkgstatus 'ii' "$#" "$@" |
9beb11aa | 1467 | msggroup |
ecb777dd DK |
1468 | } |
1469 | ||
5cf733e1 | 1470 | testdpkgnotinstalled() { |
1501a2c9 | 1471 | msggroup 'testdpkgnotinstalled' |
ecb777dd | 1472 | testdpkgstatus 'ii' '0' "$@" |
9beb11aa | 1473 | msggroup |
01a6e24c | 1474 | } |
ec7f904e DK |
1475 | |
1476 | testmarkedauto() { | |
1501a2c9 | 1477 | msggroup 'testmarkedauto' |
03938280 | 1478 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile" |
ec7f904e DK |
1479 | if [ -n "$1" ]; then |
1480 | msgtest 'Test for correctly marked as auto-installed' "$*" | |
63c71412 | 1481 | while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE" |
ec7f904e DK |
1482 | else |
1483 | msgtest 'Test for correctly marked as auto-installed' 'no package' | |
63c71412 | 1484 | echo -n > "$COMPAREFILE" |
ec7f904e | 1485 | fi |
22ac12b2 | 1486 | testoutputequal "$COMPAREFILE" aptmark showauto |
9beb11aa | 1487 | msggroup |
ec7f904e | 1488 | } |
7c2cc4a7 | 1489 | testmarkedmanual() { |
1501a2c9 | 1490 | msggroup 'testmarkedmanual' |
7c2cc4a7 DK |
1491 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile" |
1492 | if [ -n "$1" ]; then | |
1493 | msgtest 'Test for correctly marked as manually installed' "$*" | |
63c71412 | 1494 | while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE" |
7c2cc4a7 DK |
1495 | else |
1496 | msgtest 'Test for correctly marked as manually installed' 'no package' | |
63c71412 | 1497 | echo -n > "$COMPAREFILE" |
7c2cc4a7 | 1498 | fi |
22ac12b2 | 1499 | testoutputequal "$COMPAREFILE" aptmark showmanual |
9beb11aa | 1500 | msggroup |
7c2cc4a7 | 1501 | } |
89a1aa5d | 1502 | |
e52aad52 | 1503 | msgfailoutput() { |
1501a2c9 | 1504 | msgreportheader 'msgfailoutput' |
e52aad52 DK |
1505 | local MSG="$1" |
1506 | local OUTPUT="$2" | |
1507 | shift 2 | |
e52aad52 | 1508 | if [ "$1" = 'grep' ]; then |
68042532 | 1509 | echo >&2 |
e52aad52 DK |
1510 | while [ -n "$2" ]; do shift; done |
1511 | echo "#### Complete file: $1 ####" | |
1512 | cat >&2 "$1" || true | |
1513 | echo '#### grep output ####' | |
1514 | elif [ "$1" = 'test' ]; then | |
68042532 | 1515 | echo >&2 |
e52aad52 DK |
1516 | # doesn't support ! or non-file flags |
1517 | msgfailoutputstatfile() { | |
1518 | local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$' | |
1519 | if expr match "$1" "$FILEFLAGS" >/dev/null; then | |
1520 | echo "#### stat(2) of file: $2 ####" | |
1521 | stat "$2" || true | |
dffc17ba DK |
1522 | if test -d "$2"; then |
1523 | echo "#### The directory contains: $2 ####" | |
1524 | ls >&2 "$2" || true | |
1525 | elif test -e "$2"; then | |
3196dae8 DK |
1526 | echo "#### Complete file: $2 ####" |
1527 | cat >&2 "$2" || true | |
1528 | fi | |
e52aad52 DK |
1529 | fi |
1530 | } | |
1531 | msgfailoutputstatfile "$2" "$3" | |
1532 | while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do | |
1533 | shift 3 | |
1534 | msgfailoutputstatfile "$2" "$3" | |
1535 | done | |
1536 | echo '#### test output ####' | |
1537 | fi | |
63c71412 | 1538 | cat >&2 "$OUTPUT" |
e52aad52 DK |
1539 | msgfail "$MSG" |
1540 | } | |
1541 | ||
671a55ba DK |
1542 | testsuccesswithglobalerror() { |
1543 | local TYPE="$1" | |
1544 | local ERRORS="$2" | |
1545 | shift 2 | |
1546 | msggroup "$TYPE" | |
0440d936 DK |
1547 | if [ "$1" = '--nomsg' ]; then |
1548 | shift | |
1549 | else | |
1550 | msgtest 'Test for successful execution of' "$*" | |
1551 | fi | |
671a55ba | 1552 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/${TYPE}.output" |
63c71412 | 1553 | if "$@" >"${OUTPUT}" 2>&1; then |
4fa34122 | 1554 | if expr match "$1" '^apt.*' >/dev/null; then |
e52aad52 DK |
1555 | if grep -q -E ' runtime error: ' "$OUTPUT"; then |
1556 | msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@" | |
671a55ba | 1557 | elif grep -E "^[${ERRORS}]: " "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then |
3261271e DK |
1558 | if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then |
1559 | if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \ | |
1560 | | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then | |
1561 | msgpass | |
1562 | else | |
1563 | msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@" | |
1564 | fi | |
1565 | else | |
1566 | msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@" | |
1567 | fi | |
671a55ba DK |
1568 | elif [ "$TYPE" = 'testsuccesswithnotice' ]; then |
1569 | if grep -q -E "^N: " "$OUTPUT"; then | |
1570 | msgpass | |
1571 | else | |
1572 | msgfailoutput 'successful run, but output had no notices' "$OUTPUT" "$@" | |
1573 | fi | |
4fa34122 DK |
1574 | else |
1575 | msgpass | |
1576 | fi | |
1577 | else | |
1578 | msgpass | |
1579 | fi | |
1580 | else | |
1581 | local EXITCODE=$? | |
e52aad52 | 1582 | msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@" |
4fa34122 | 1583 | fi |
671a55ba | 1584 | aptautotest "$TYPE" "$@" |
9beb11aa | 1585 | msggroup |
4fa34122 | 1586 | } |
671a55ba DK |
1587 | testsuccesswithnotice() { |
1588 | testsuccesswithglobalerror 'testsuccesswithnotice' 'WE' "$@" | |
1589 | } | |
1590 | testsuccess() { | |
1591 | testsuccesswithglobalerror 'testsuccess' 'NWE' "$@" | |
1592 | } | |
4fa34122 | 1593 | testwarning() { |
1501a2c9 | 1594 | msggroup 'testwarning' |
4fa34122 DK |
1595 | if [ "$1" = '--nomsg' ]; then |
1596 | shift | |
1597 | else | |
1598 | msgtest 'Test for successful execution with warnings of' "$*" | |
1599 | fi | |
25b86db1 | 1600 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" |
63c71412 | 1601 | if "$@" >"${OUTPUT}" 2>&1; then |
1df24acf | 1602 | if expr match "$1" '^apt.*' >/dev/null; then |
e52aad52 DK |
1603 | if grep -q -E ' runtime error: ' "$OUTPUT"; then |
1604 | msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@" | |
1605 | elif grep -q -E '^E: ' "$OUTPUT"; then | |
1606 | msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@" | |
4fa34122 | 1607 | elif ! grep -q -E '^W: ' "$OUTPUT"; then |
e52aad52 | 1608 | msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@" |
1df24acf DK |
1609 | else |
1610 | msgpass | |
1611 | fi | |
1612 | else | |
1613 | msgpass | |
1614 | fi | |
0440d936 | 1615 | else |
07cb47e7 | 1616 | local EXITCODE=$? |
68042532 | 1617 | msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@" |
0440d936 | 1618 | fi |
4fa34122 | 1619 | aptautotest 'testwarning' "$@" |
9beb11aa | 1620 | msggroup |
0440d936 | 1621 | } |
0440d936 | 1622 | testfailure() { |
1501a2c9 | 1623 | msggroup 'testfailure' |
0440d936 DK |
1624 | if [ "$1" = '--nomsg' ]; then |
1625 | shift | |
1626 | else | |
889b0072 | 1627 | msgtest 'Test for failure in execution of' "$*" |
0440d936 | 1628 | fi |
03938280 | 1629 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" |
63c71412 | 1630 | if "$@" >"${OUTPUT}" 2>&1; then |
07cb47e7 | 1631 | local EXITCODE=$? |
e52aad52 | 1632 | msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@" |
0440d936 | 1633 | else |
1df24acf DK |
1634 | local EXITCODE=$? |
1635 | if expr match "$1" '^apt.*' >/dev/null; then | |
b0d40854 DK |
1636 | if [ "$1" = 'aptkey' ]; then |
1637 | if grep -q -E " Can't check signature: " "$OUTPUT" || \ | |
1638 | grep -q -E " BAD signature from " "$OUTPUT"; then | |
1639 | msgpass | |
1640 | else | |
1641 | msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@" | |
1642 | fi | |
1df24acf | 1643 | else |
b0d40854 DK |
1644 | if grep -q -E ' runtime error: ' "$OUTPUT"; then |
1645 | msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@" | |
1646 | elif grep -q -E '==ERROR' "$OUTPUT"; then | |
1647 | msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@" | |
1648 | elif ! grep -q -E '^E: ' "$OUTPUT"; then | |
1649 | msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@" | |
1650 | else | |
1651 | msgpass | |
1652 | fi | |
1df24acf DK |
1653 | fi |
1654 | else | |
1655 | msgpass | |
1656 | fi | |
0440d936 | 1657 | fi |
ab25bf1f | 1658 | aptautotest 'testfailure' "$@" |
9beb11aa | 1659 | msggroup |
0440d936 DK |
1660 | } |
1661 | ||
7414af7f DK |
1662 | testreturnstateequal() { |
1663 | local STATE="$1" | |
671a55ba DK |
1664 | if [ "$STATE" = 'testsuccesswithglobalerror' ]; then |
1665 | local STATE="$2" | |
1666 | local TYPE="$3" | |
7414af7f | 1667 | shift 3 |
671a55ba DK |
1668 | msggroup "${STATE}equal" |
1669 | if [ "$1" != '--nomsg' ]; then | |
1670 | local CMP="$1" | |
1671 | shift | |
1672 | testsuccesswithglobalerror "$STATE" "$TYPE" "$@" | |
1673 | testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP" | |
1674 | else | |
1675 | local CMP="$2" | |
1676 | shift 2 | |
1677 | testsuccesswithglobalerror "$STATE" "$TYPE" "$@" | |
1678 | testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP" | |
1679 | fi | |
1680 | else | |
1681 | msggroup "${STATE}equal" | |
1682 | if [ "$2" != '--nomsg' ]; then | |
1683 | local CMP="$2" | |
1684 | shift 2 | |
1685 | "$STATE" "$@" | |
1686 | testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP" | |
1687 | else | |
1688 | local CMP="$3" | |
1689 | shift 3 | |
1690 | "$STATE" --nomsg "$@" | |
1691 | testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP" | |
1692 | fi | |
7414af7f | 1693 | fi |
9beb11aa | 1694 | msggroup |
25b86db1 | 1695 | } |
7414af7f | 1696 | testsuccessequal() { |
671a55ba DK |
1697 | # we compare output, so we know perfectly well about N: |
1698 | testreturnstateequal 'testsuccesswithglobalerror' 'testsuccess' 'WE' "$@" | |
7414af7f | 1699 | } |
25b86db1 | 1700 | testwarningequal() { |
7414af7f | 1701 | testreturnstateequal 'testwarning' "$@" |
25b86db1 DK |
1702 | } |
1703 | testfailureequal() { | |
7414af7f | 1704 | testreturnstateequal 'testfailure' "$@" |
25b86db1 DK |
1705 | } |
1706 | ||
27925d82 | 1707 | testfailuremsg() { |
1501a2c9 | 1708 | msggroup 'testfailuremsg' |
27925d82 DK |
1709 | local CMP="$1" |
1710 | shift | |
1711 | testfailure "$@" | |
1712 | msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings' | |
68042532 | 1713 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile" |
002b1bc4 | 1714 | grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true |
22ac12b2 | 1715 | testoutputequal "$COMPAREFILE" echo "$CMP" |
9beb11aa | 1716 | msggroup |
27925d82 | 1717 | } |
f18f2338 DK |
1718 | testwarningmsg() { |
1719 | msggroup 'testwarningmsg' | |
1720 | local CMP="$1" | |
1721 | shift | |
1722 | testwarning "$@" | |
1723 | msgtest 'Check that the output of the previous warned command has expected' 'warnings' | |
1724 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarningmsg.comparefile" | |
002b1bc4 | 1725 | grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" > "$COMPAREFILE" 2>&1 || true |
f18f2338 DK |
1726 | testoutputequal "$COMPAREFILE" echo "$CMP" |
1727 | msggroup | |
1728 | } | |
25b86db1 | 1729 | |
de81b2e2 | 1730 | testfilestats() { |
1501a2c9 | 1731 | msggroup 'testfilestats' |
de81b2e2 DK |
1732 | msgtest "Test that file $1 has $2 $3" "$4" |
1733 | if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then | |
5684f71f DK |
1734 | msgpass |
1735 | else | |
68042532 DK |
1736 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output" |
1737 | { | |
1738 | ls -ld "$1" || true | |
1739 | echo -n "stat(1) reports for $2: " | |
1740 | stat --format "$2" "$1" || true | |
1741 | } >"$OUTPUT" 2>&1 | |
1742 | msgfailoutput '' "$OUTPUT" | |
5684f71f | 1743 | fi |
9beb11aa | 1744 | msggroup |
5684f71f | 1745 | } |
de81b2e2 | 1746 | testaccessrights() { |
1501a2c9 | 1747 | msggroup 'testaccessrights' |
de81b2e2 | 1748 | testfilestats "$1" '%a' '=' "$2" |
9beb11aa | 1749 | msggroup |
de81b2e2 | 1750 | } |
5684f71f | 1751 | |
0d58c26a | 1752 | testwebserverlaststatuscode() { |
1501a2c9 | 1753 | msggroup 'testwebserverlaststatuscode' |
0d58c26a | 1754 | local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log' |
03aa0847 | 1755 | local STATUS='downloaded/webserverstatus-statusfile.log' |
0d58c26a DK |
1756 | rm -f "$DOWNLOG" "$STATUS" |
1757 | msgtest 'Test last status code from the webserver was' "$1" | |
6c0765c0 | 1758 | if downloadfile "http://localhost:${APTHTTPPORT}/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then |
0d58c26a DK |
1759 | msgpass |
1760 | else | |
68042532 DK |
1761 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output" |
1762 | { | |
1763 | if [ -n "$2" ]; then | |
1764 | shift | |
1765 | echo >&2 '#### Additionally provided output files contain:' | |
1766 | cat >&2 "$@" | |
1767 | fi | |
1768 | echo >&2 '#### Download log of the status code:' | |
1769 | cat >&2 "$DOWNLOG" | |
1770 | } >"$OUTPUT" 2>&1 | |
1771 | msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT" | |
0d58c26a | 1772 | fi |
9beb11aa | 1773 | msggroup |
0d58c26a DK |
1774 | } |
1775 | ||
785cb6fc DK |
1776 | createlistofkeys() { |
1777 | local OUTPUT="$1" | |
1778 | shift | |
1779 | while [ -n "$1" ]; do | |
1780 | # gpg 2.1 has a slightly different output format | |
1781 | if grep -q ' rsa2048/' "$OUTPUT"; then | |
1782 | case "$1" in | |
1783 | *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18';; | |
1784 | *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [expired: 2013-07-13]';; | |
1785 | *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16';; | |
1786 | oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19';; | |
1787 | newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18';; | |
1788 | *) echo 'UNKNOWN KEY';; | |
1789 | esac | |
1790 | else | |
1791 | case "$1" in | |
1792 | *Joe*|*Sixpack*) echo 'pub 2048R/DBAC8DAE 2010-08-18';; | |
1793 | *Rex*|*Expired*) echo 'pub 2048R/27CE74F9 2013-07-12 [expired: 2013-07-13]';; | |
1794 | *Marvin*|*Paranoid*) echo 'pub 2048R/528144E2 2011-01-16';; | |
1795 | oldarchive) echo 'pub 1024R/F68C85A3 2013-12-19';; | |
1796 | newarchive) echo 'pub 2048R/DBAC8DAE 2010-08-18';; | |
1797 | *) echo 'UNKNOWN KEY';; | |
1798 | esac | |
1799 | fi | |
1800 | shift | |
1801 | done | |
1802 | } | |
1803 | testaptkeys() { | |
1804 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/aptkeylist.output" | |
1805 | if ! aptkey list | grep '^pub' > "$OUTPUT"; then | |
1806 | echo -n > "$OUTPUT" | |
1807 | fi | |
1808 | testfileequal "$OUTPUT" "$(createlistofkeys "$OUTPUT" "$@")" | |
1809 | } | |
1810 | ||
89a1aa5d DK |
1811 | pause() { |
1812 | echo "STOPPED execution. Press enter to continue" | |
1813 | local IGNORE | |
1814 | read IGNORE | |
1815 | } | |
ab25bf1f | 1816 | |
846bc058 | 1817 | listcurrentlistsdirectory() { |
ba6b79bd DK |
1818 | { |
1819 | find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do | |
1820 | stat --format '%U:%G:%a:%n' "$line" | |
1821 | done | |
1822 | find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do | |
1823 | stat --format '%U:%G:%a:%s:%y:%n' "$line" | |
1824 | done | |
1825 | } | sort | |
846bc058 | 1826 | } |
912a6131 DK |
1827 | forallsupportedcompressors() { |
1828 | for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do | |
0179cfa8 | 1829 | if [ -z "$COMP" -o "$COMP" = '.' ]; then continue; fi |
912a6131 DK |
1830 | "$@" "$COMP" |
1831 | done | |
1832 | } | |
846bc058 | 1833 | |
3a8776a3 | 1834 | ### convenience hacks ### |
8fe964f1 DK |
1835 | mkdir() { |
1836 | # creating some directories by hand is a tedious task, so make it look simple | |
6aef1942 DK |
1837 | local PARAMS="$*" |
1838 | if [ "$PARAMS" != "${PARAMS#*rootdir/var/lib/apt/lists}" ]; then | |
8fe964f1 DK |
1839 | # only the last directory created by mkdir is effected by the -m ! |
1840 | command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" | |
1841 | command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" | |
1842 | command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" | |
1843 | touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock" | |
1844 | if [ "$(id -u)" = '0' ]; then | |
1845 | chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" | |
1846 | fi | |
1847 | else | |
1848 | command mkdir "$@" | |
1849 | fi | |
1850 | } | |
1851 | ||
ab25bf1f DK |
1852 | ### The following tests are run by most test methods automatically to check |
1853 | ### general things about commands executed without writing the test every time. | |
1854 | ||
1855 | aptautotest() { | |
1856 | local TESTCALL="$1" | |
1857 | local CMD="$2" | |
1858 | local FIRSTOPT="$3" | |
63c71412 | 1859 | local AUTOTEST="aptautotest_$(echo "${CMD##*/}_${FIRSTOPT}" | tr -d '-')" |
ab25bf1f DK |
1860 | if command -v $AUTOTEST >/dev/null; then |
1861 | shift 3 | |
1862 | # save and restore the *.output files from other tests | |
1863 | # as we might otherwise override them in these automatic tests | |
63c71412 DK |
1864 | rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" |
1865 | mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" | |
1866 | mkdir "${TMPWORKINGDIRECTORY}/rootdir/tmp" | |
ab25bf1f | 1867 | $AUTOTEST "$TESTCALL" "$@" |
63c71412 DK |
1868 | rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest" |
1869 | mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest" | |
1870 | mv "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" "${TMPWORKINGDIRECTORY}/rootdir/tmp" | |
ab25bf1f DK |
1871 | fi |
1872 | } | |
1873 | ||
1874 | aptautotest_aptget_update() { | |
59148d96 DK |
1875 | local TESTCALL="$1" |
1876 | while [ -n "$2" ]; do | |
1877 | if [ "$2" = '--print-uris' ]; then return; fi # simulation mode | |
1878 | shift | |
1879 | done | |
ab25bf1f | 1880 | if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi |
4bb006d1 DK |
1881 | testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755" |
1882 | testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755" | |
ab25bf1f | 1883 | # all copied files are properly chmodded |
63c71412 DK |
1884 | local backupIFS="$IFS" |
1885 | IFS="$(printf "\n\b")" | |
146f7715 | 1886 | for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do |
4bb006d1 | 1887 | testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644" |
ab25bf1f | 1888 | done |
63c71412 | 1889 | IFS="$backupIFS" |
59148d96 | 1890 | if [ "$TESTCALL" = 'testsuccess' ]; then |
146f7715 DK |
1891 | # failure cases can retain partial files and such |
1892 | testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \) | |
1893 | fi | |
ab25bf1f DK |
1894 | } |
1895 | aptautotest_apt_update() { aptautotest_aptget_update "$@"; } | |
d84da499 | 1896 | aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; } |
016bea82 DK |
1897 | |
1898 | testaptautotestnodpkgwarning() { | |
1899 | local TESTCALL="$1" | |
1900 | while [ -n "$2" ]; do | |
6bf93605 DK |
1901 | if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode |
1902 | if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode | |
016bea82 DK |
1903 | shift |
1904 | done | |
1905 | testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output" | |
1906 | } | |
1907 | ||
1908 | aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; } | |
1909 | aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; } | |
1910 | aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; } | |
1911 | aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; } | |
1912 | aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; } | |
1913 | aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; } |